<?php

class CachedJson
{
    public $path;
    public $map;

    public function __construct($path) {
        $this->path = $path;
        $this->map = array();
    }

    public function reload() {
        if (!is_file($this->path)) {
            $this->map = array();
            return;
        }

        $this->map = json_decode(file_get_contents($this->path), true);
        if (!isset($this->map))
            $this->map = array();
    }

    public function set_map($map)
    {
        $this->map = isset($map) ? $map : array();
        $this->save();
    }

    public function put($key, $val)
    {
        $this->map[$key] = $val;
    }

    public function save()
    {
        $doc = json_encode($this->map);
        HD::write_to_file_using_tmp_if_changed($this->path, $doc);
    }
}

?>
