<?php

class SeasonsScreen extends BaseListScreen
{
    const ID = 'seasons';

    public static function get_media_url_str($movie_id)
    {
        $arr = array(
            'screen_id' => self::ID,
            'movie_id' => $movie_id,
        );
        return MediaURL::encode($arr);
    }

    ///////////////////////////////////////////////////////////////////////

    public function __construct() {
        parent::__construct(self::ID);
    }

    public function get_handler_id() {
        return self::ID;
    }

    ///////////////////////////////////////////////////////////////////////

    // EEE TODO: copy-n-paste
    public function get_folder_view(MediaURL $media_url, &$plugin_cookies)
    {
        $this->set_folder_views(null);
        return parent::get_folder_view($media_url, $plugin_cookies);
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_action_map(MediaURL $media_url, &$plugin_cookies)
    {
        return array(
            GUI_EVENT_KEY_ENTER => $this->custom_action('enter'),
            GUI_EVENT_KEY_INFO => $this->custom_action('info'),
            GUI_EVENT_MENU_PLAYBACK_FINISH =>
                $this->custom_action("menu_playback_finish"),
        );
    }

    ///////////////////////////////////////////////////////////////////////

    public function get_all_folder_items(
        MediaURL $media_url, &$plugin_cookies)
    {
        $items = array();

        $mts = MainHelper::$state->nav_mts;
        $mts->ensure_torrents_info(false);

        $url = "plugin_file://%shell_ext%/icons/folder_small.png";

        $seasons = $mts->get_torrent_seasons();
        foreach ($seasons as $s)
        {
            $vip = array(ViewItemParams::icon_path => $url);
            $vip[ViewItemParams::item_caption_dy] = -2;
            $vip[ViewItemParams::item_caption_sel_dy] = -2;

            $caption = UrlHelper::get_season_caption($s);
            $murl = self::get_item_media_url($s);

            $items[] = array(
                PluginRegularFolderItem::media_url => $murl,
                PluginRegularFolderItem::caption => $caption,
                PluginRegularFolderItem::view_item_params => $vip,
            );
        }

        return $items;
    }

    ///////////////////////////////////////////////////////////////////////

    public static function get_item_media_url($ndx)
    {
        return $ndx;
    }

    private function menu_playback_finish($user_input)
    {
        return TorrentHelper::menu_playback_finish($user_input);
    }

    public function handle_user_input(&$user_input, &$plugin_cookies)
    {
        hd_print('Seasons screen: handle_user_input:');
        foreach ($user_input as $key => $value)
            hd_print("  $key => $value");

        $st = MainHelper::$state;
        $mts = $st->nav_mts;
        $m = $mts->get_movie();

        $s = (int) HD::get($user_input, 'chosen_media_url',
            HD::get($user_input, 'selected_media_url', -1));

        if ($user_input->control_id == 'enter')
        {
            $chosen_only = $s >= 1;
            $stack = "S2:$s;";
            $media_url_str = TorrentsScreen::get_media_url_str(
                $m->id, $s, -1, $chosen_only, $stack);

            $sel_id = null;
            $post_action = null;

            if (isset($user_input->torrent_sel_id))
            {
                $sel_id = $user_input->torrent_sel_id;
                $enter_torrent_action =
                    HD::get($user_input, 'enter_torrent_action');
                if ($enter_torrent_action)
                    $post_action = json_decode($enter_torrent_action, true);
            }

            $st->enter_season($s);
            return ActionFactory::open_folder_ext($media_url_str,
                UrlHelper::get_season_caption($s),
                null, $sel_id, $post_action);
        }

        if ($user_input->control_id == 'menu_playback_finish')
            return $this->menu_playback_finish($user_input);

        return null;
    }
}
